***************************************************************************
*
* Procedure file: SAYDIS
*        Version: 1.10.01
*       Released: November 19, 1995
*         System: FoxPro 2.5 or higher, GENSCRNX 2.0 or higher, 3D
*         Author: Jason M. Landry, CompuServe 74473,3256
*         e-mail: internet: jlandry@exch.com
*        Company: Exchange Resources, Inc. (Minneapolis, Minnesota)
*      Copyright: 1995, Jason Landry.  ALL RIGHTS RESERVED.
*
*  NOTE:  I have set up a www page for drivers, tips etc., that
*  I have found useful.  The URL is http://www.exch.com/fox.htm (not HTML!).
*  I ask that if you find anything useful here, you spend some time with
*  my employer's home page, as they have been kind enough to allow me to
*  do this.  And please send me feedback if you use my stuff.  I like a 
*  pat or two on the back, too.
*
*
*  DEVELOPMENT NOTES
*
*   FoxPro Bugs
*   -----------
*   I have run into some wierd happenings with trying to get fonts to line
*   up exactly right.  Under certain circumstances, @ ... SAYs won't line
*   up on top of each other (which is essential for this driver!).  I have
*   narrowed it down to this:
*   @ 5.100, 7.100 SAY 'Something'
*   @ EVAL('5.100'), 7.100 SAY 'Something'
*   Apparently, the SAY command sees these two numbers a little differently.
*   This is not always duplicatable, but I suspect it has something to do
*   with the way FoxPro internally rounds numbers.  For this reason, I was
*   forced to used macro expansion to update the screen (I know, I know,
*   you hate macro expansion).  If anyone can come up with a workaround that
*   forces the above example to *always* work the same, please let me know.
*
*   Other Gotchas
*   -------------
*   I am still working on the code for SHOW GETS ENAB and SHOW GETS DISA
*   It should work fine if you want to use it, but (embarrasingly enough) the
*   3DCTRL driver that I wrote does *not* work with the SHOW GETS ENAB/DISAB
*   commands.  That's something I'd like to fix.  How many people actually
*   use these commands anyway?
*
*   Use with TABS driver
*   --------------------
*   Although I haven't tested the functionality extensively, this driver
*   is designed to work with Steven Black's TABS driver (are we going to
*   have a 'Compatible With Tabs' slogan soon?)  It was tested with version
*   2.0 and 2.6 of the TABS driver, but WORKS ONLY UNDER WINDOWS.
*   IMPORTANT!  IMPORTANT!  This driver must come *AFTER* the TABS driver.
*
*
*   Revision History
*   ================	
*   Date      Version Notes
*   --------- ------- ------------------------------------------------------
*   19-Nov-95 1.0     Initial Release
*   20-Nov-95 1.00.01 Fixed problem string comparison (changed = to ==) 
*	03-Jan-96 1.10.00 Disabled text looks more Win95-like
*  
****************************************************************************
*  ALL SOURCE CODE COPYRIGHT 1995 JASON LANDRY.  PERMISSION IS GRANTED TO
*  TO USERS OF THIS PROGRAM TO MODIFY THIS SOURCE CODE AS NECESSARY PROVIDED
*  THE FOLLOWING CONDITIONS ARE MET:
*  1) MODIFIED SOURCE MAY NOT BE USED IN A COMMERCIAL APPLICATION (DEFINED
*     AS AN APPLICATION SOLD TO THAN TEN DISTINCT ENTITIES) WITHOUT EXPRESS
*     WRITTEN CONSENT OF THE AUTHOR.
*  2) YOU MAY MODIFY THIS SOURCE TO YOUR HEARTS CONTENT, BUT UNDER NO 
*     CIRCUMSTANCES MAY ANYONE DISTRIBUTE MODIFIED SOURCE CODE.
*     PERIOD!  EVEN IF YOU ASK ME FOR TWO WEEKS TO FIX SOMETHING AND I
*     DON'T HAVE TIME TO DO IT, YOU STILL CAN'T DISTRIBUTE YOUR FIXES TO
*     OTHER PEOPLE.  ESPECIALLY IF YOU RENAME THE PROGRAM TO SOMETHING, OH
*     LIKE INSAYDIS.PRG.  I WORKED HARD ON THIS, AND I WANT THE GLORY!
*  3) YOU MUST ROOT FOR THE MINNESOTA VIKINGS WHEN THEY PLAY AGAINST ANY
*     OF THE FOLLOWING TEAMS:  CHICAGO, GREEN BAY, DETROIT and TAMPA BAY.
*  4) YOU MUST NOT LAUGH AT ANY MENTION OF "The Minnesota Timberwolves"
***************************************************************************
*
* SAYDIS - Automatically 'grays out' text to the left of a text field
*          when that get field is disabled.
*
* Place the line "*:SCXDRV5 SAYDIS" in any screen (after TABS driver).
* Any time a get field is disabled using SHOW GET myVar DISABLE, the
* text immediately to the left will be disabled-looking too.  This is
* especially effective when the get field has no data in it.
*
* Placing a *:SAYDIS OFF in the comment snippet of a get field will disable
* processing for that field (useful if you have two fields in a row like
* the sample screen).
********************************************************************************

*-SCX Objtypes
#DEFINE cntext			5
#DEFINE cnline			6
#DEFINE cnbox			7
#DEFINE cnlist			11
#DEFINE cnpushbutton	12
#DEFINE cnradiobutton	13
#DEFINE cncheckbox		14
#DEFINE cnsayget		15
#DEFINE cnpopup			16
#DEFINE cnpicture		17
#DEFINE cnspinner		22
#DEFINE cninvbutton
#DEFINE cnexpression	0
#DEFINE cnprocedure		1
#DEFINE cngetcode		1
#DEFINE ccnull			CHR(0)
#DEFINE cnnormalwt		0
#DEFINE cnboldwt		1
#DEFINE cfssay 1
#DEFINE cfsget 2
#DEFINE cfsmsg 3
#DEFINE cfswhn 4
#DEFINE cfsval 5
#DEFINE cfspic 6
#DEFINE cfsokl 7
#DEFINE cnheader 4
#DEFINE cnscreen 5
#DEFINE cobjarray 4

IF m.scxcount=1
	RELEASE _sd_aHold
	PUBLIC _sd_aHold
ENDIF
IF m.scxcount=m.screens
	*- Identify the areas where code can exist
	PRIVATE headercode, screencode, lDoCode
	PRIVATE nvFoxel, nhFoxel
	DIMENSION headercode(5)
	DIMENSION screencode(5)
	headercode(1)='show'
	headercode(2)='setupcode'
	headercode(3)='activate'
	headercode(4)='deactivate'
	headercode(5)='proccode'
	screencode(1)='when'
	screencode(2)='valid'
	screencode(3)='message'
 	screencode(4)='error'
	screencode(5)='comment'
ENDIF
PRIVATE i, j, jj, aflds, _sd_temp, nGetRec, nTemp, cWinName, cStyle, cPict

*- Make all memory variables for the screen table (.scx) private
FOR i=1 TO AFIELDS(aflds)
	PRIVATE (aflds(i,1))
ENDFOR

*- Get the name of the current window
IF EMPTY(name)
	REPLACE name WITH SYS(2015)	&& need a screen name!
ENDIF
m.cWinName=UPPER(name)
cAlias=ALIAS()
nvFoxel=1/FONTMETRIC(1,fontface,fontsize,TRIM(SUBSTR("N B I BI",fontstyle*2+1,2)))
nhFoxel=1/FONTMETRIC(6,fontface,fontsize,TRIM(SUBSTR("N B I BI",fontstyle*2+1,2)))

*- Look for objects that qualify
SCAN FOR (objcode=1 AND objtype=15) AND !DELETED() AND wordsearch("*:SAYDIS ","comment")<>"OFF"
	DO updthrm WITH "","[WINDOWS] "+LOWER(PROGRAM()),RECNO()/RECCOUNT()*100
	SCATTER MEMVAR MEMO
	SELECT * FROM (DBF());
		WHERE vpos<m.vpos+.5*HEIGHT AND vpos>m.vpos-.5*HEIGHT AND hpos<m.hpos;
		AND ( ( objtype=15 AND objcode=0) OR ( objtype=5  AND objcode=0) );
		AND !EMPTY(expr);
		AND !DELETED();
		INTO CURSOR cTemp
	*- cTemp now contains the 'candidates' for graying out text.
	*- Find the one closest horizontally.
	IF _TALLY>0
		CALCULATE MAX(hpos) TO nTemp
		LOCATE FOR hpos=nTemp
		cID=uniqueid
		USE IN cTemp
		SELECT (cAlias)

		SELECT * FROM (DBF());
			WHERE uniqueid=CID AND !DELETED();
			INTO ARRAY _sd_Temp

		IF _TALLY>0
			IF disabled	&& Need to modify the say for the first round through
				nGetRec=RECNO()
				LOCATE FOR uniqueid=cID AND !DELETED()
				REPLACE penred WITH 128,;
					penblue WITH 128,;
					pengreen WITH 128
				GO nGetRec
			ENDIF

			* Store to an array the values that will be used to create the function call.
			cStyle=TRIM(SUBSTR("N B I BI",fldArray(@aFlds,'FONTSTYLE',@_sd_Temp)*2+1,2))+;
				IIF(fldArray(@aFlds,'OBJTYPE',@_sd_Temp)=5,'T','')
			cPict=trimdelim(fldArray(@aFlds,'PICTURE',@_sd_Temp))
			DIMENSION _sd_aHold(IIF(TYPE('_sd_aHold(1,1)')<>'C',1,ALEN(_sd_aHold,1)+1),cobjarray)
			_sd_aHold(ALEN(_sd_aHold,1),1)=justvar(name)	&& Variable to look for
			_sd_aHold(ALEN(_sd_aHold,1),2)="'"+cWinName+"'"
			_sd_aHold(ALEN(_sd_aHold,1),3)="[@ "+;
				STR(fldArray(@aFlds,'VPOS',@_sd_Temp),7,3)+","+;
				STR(fldArray(@aFlds,'HPOS',@_sd_Temp),7,3)+" SAY "+;
				fldArray(@aFlds,'EXPR',@_sd_Temp)+' FONT '+;
				"'"+fldArray(@aFlds,'FONTFACE',@_sd_Temp)+"',"+;
				LTRIM(STR(fldArray(@aFlds,'FONTSIZE',@_sd_Temp),4,0))+" SIZE "+;
				STR(fldArray(@aFlds,'HEIGHT',@_sd_Temp),7,3)+","+;
				STR(fldArray(@aFlds,'WIDTH',@_sd_Temp),7,3)+" "+;
				IIF(!EMPTY(cStyle),"STYLE 'T"+cStyle+"' ","")+' '+;
				IIF(!EMPTY(cPict),"PICTURE '"+cPict+"' ","")+']'
				
			**- Added 3D win95 looking disable
			_sd_aHold(ALEN(_sd_aHold,1),4)="[@ "+;
				STR(fldArray(@aFlds,'VPOS',@_sd_Temp)+nvFoxel,7,3)+","+;
				STR(fldArray(@aFlds,'HPOS',@_sd_Temp)+nhFoxel,7,3)+" SAY "+;
				fldArray(@aFlds,'EXPR',@_sd_Temp)+' FONT '+;
				"'"+fldArray(@aFlds,'FONTFACE',@_sd_Temp)+"',"+;
				LTRIM(STR(fldArray(@aFlds,'FONTSIZE',@_sd_Temp),4,0))+" SIZE "+;
				STR(fldArray(@aFlds,'HEIGHT',@_sd_Temp),7,3)+","+;
				STR(fldArray(@aFlds,'WIDTH',@_sd_Temp),7,3)+" "+;
				IIF(!EMPTY(cStyle),"STYLE 'T"+cStyle+"' ","")+' '+;
				IIF(!EMPTY(cPict),"PICTURE '"+cPict+"' ","")+']'
		ENDIF
	ENDIF
ENDSCAN

IF m.scxcount=m.screens
	lDoCode=.F.		&& Don't add support if not needed.
	SELECT 0
	FOR i=1 TO m.screens
		USE (a_fscxdata(i)) AGAIN ALIAS sxdata
		FOR j=1 TO ALEN(headercode,1)
			=AddCode(headercode(j),@_sd_aHold)
		ENDFOR
		SKIP
		SCAN REST
			FOR j=1 TO ALEN(screencode,1)
				=AddCode(screencode(j),@_sd_aHold)
			ENDFOR
		ENDSCAN
	ENDFOR && i=number of screens
	RELEASE _sd_aHold
	USE
	USE (a_fscxdata(1)) AGAIN ALIAS sxdata
	* In the function below,
	* w=Window Name
	* m=Macro expansion code
	REPLACE PROCCODE WITH PROCCODE+m.cr_lf+;
		'FUNCTION _sd_sayfnc'+m.cr_lf+;
		'PARAMETER w,m1,m2,l1'+m.cr_lf+;
		'*- Added by SAYDIS genscrnx driver by Jason Landry'+m.cr_lf+;
		'PRIVATE z'+m.cr_lf+;
		'z=WOUTPUT()'+m.cr_lf+;
		'IF z<>w'+m.cr_lf+;
		'	ACTI WIND (w) SAME'+m.cr_lf+;
		'ENDIF'+m.cr_lf+;
		'IF l1'+m.cr_lf+;
		'  m2=m2+" COLOR RGB(192,192,192,,,)"'+m.cr_lf+;
		'  m1=m1+" COLOR RGB(0,0,0,,,)"'+m.cr_lf+;
		'ELSE'+m.cr_lf+;
		'  m2=m2+" COLOR RGB(255,255,255,,,)"'+m.cr_lf+;
		'  m1=m1+" COLOR RGB(128,128,128,,,)"'+m.cr_lf+;	
		'ENDIF'+m.cr_lf+;
		'&m2'+m.cr_lf+;
		'&m1'+m.cr_lf+;
		'ACTI WIND (z) SAME'+m.cr_lf
	USE
	SELECT (cAlias)
ENDIF	&& scxcount=m.screens
GO BOTTOM

FUNCTION AddCode
PARAMETER cMemo, tVals
PRIVATE i, j, nCut, cTmp, cRepl, cAction

FOR j=1 TO ALEN(tVals,1)
	i=ATC('SHOW GET',EVAL(cMemo))
	cTmp=SUBSTR(EVAL(cMemo),i)
	nCut=i-1
	DO WHILE i>0
		cAction=LEFT(extword(4,ctmp),4)
		IF INLIST(cAction,'ENAB','DISA') AND justvar(extword(3,cTmp))==tVals(j,1)
			lDoCode=.T.
			cRepl=''
			FOR K=2 TO ALEN(tVals,2)
				cRepl=cRepl+',;'+m.cr_lf+tvals(j,K)
			ENDFOR
			cRepl='=_sd_sayfnc('+SUBSTR(cRepl,2)+','+;
				IIF(cAction='DISA','.f.','.t.')+;
				')'+CHR(38)+CHR(38)+' Added by SAYDIS'+CHR(13)
			REPLACE (cMemo) WITH STUFF(EVAL(cMemo),nCut,0,cRepl)
			nCut=nCut+LEN(cRepl)
		ELSE									&& Check for SHOW GETS ENAB/DISAB
			cAction=LEFT(extword(3,ctmp),4)
			IF INLIST(cAction,'ENAB','DISA')	&& This must be SHOW GETS
				lDoCode=.T.
				FOR jj=1 to ALEN(tVals,1)
					cRepl=''
					FOR K=2 TO ALEN(tVals,2)
				cRepl=cRepl+',;'+m.cr_lf+tvals(jj,K)
					ENDFOR
					cRepl='=_sd_sayfnc('+SUBSTR(cRepl,2)+','+;
						IIF(cAction='DISA','.f.','.t.')+;
						')'+CHR(38)+CHR(38)+' Added by SAYDIS'+CHR(13)
					REPLACE (cMemo) WITH STUFF(EVAL(cMemo),nCut,0,cRepl)
					nCut=nCut+LEN(cRepl)
				ENDFOR
			ENDIF
		ENDIF	
		i=ATC('SHOW GET',cTmp,2)
		nCut=nCut+i-1
		cTmp=SUBSTR(cTmp,i)
	ENDDO
ENDFOR

FUNCTION justvar
PARAMETER cWord
RETURN UPPER(IIF('.'$cWord,SUBSTR(cWord,AT('.',cWord)+1),cWord))

FUNCTION extword
* Extracts <pnword> word out of code snippets
PARAMETER pnword,pcsearch,pcdelims,pcdelimit
PRIVATE i,lnwc,lawords,lcsw,llindelimit,lcendlimit,lcchar
i=0
IF EMPTY(pcdelimit)
	pcdelimit=""
ENDIF
IF EMPTY(pcdelims)
	pcdelims=' ;'+CHR(9)+CHR(13)+CHR(10)
ENDIF
lnwc=1
lcsw=""
llindelimit=.F.
lcendlimit=""
DIMENSION lawords(1)
DO WHILE i<=LEN(pcsearch) AND lnwc<=pnword
	i=i+1
	lcchar=SUBSTR(pcsearch,i,1)
	DO CASE
		CASE !llindelimit AND ATC(lcchar,pcdelimit)%2=1
			llindelimit=.T.
			lcendlimit=SUBSTR(pcdelimit,AT(lcchar,pcdelimit)+1,1)
			lcsw=lcsw+lcchar
		CASE llindelimit AND lcchar<>lcendlimit
			lcsw=lcsw+lcchar
		CASE llindelimit AND lcchar==lcendlimit
			llindelimit=.F.
			lcsw=lcsw+lcchar
		CASE EMPTY(lcsw) AND ATC(lcchar,pcdelims)>0
			* don't count as an extra word
		CASE ATC(lcchar,pcdelims)>0
			DIMENSION lawords(lnwc)
			lawords(lnwc)=lcsw
			lcsw=""
			lnwc=lnwc+1
		CASE i=LEN(pcsearch)
			DIMENSION lawords(lnwc)
			lawords(lnwc)=lcsw+lcchar
		OTHERWISE
			lcsw=lcsw+lcchar
	ENDCASE
ENDDO
IF TYPE('lawords(pnword)')='C'
	RETURN lawords(pnword)
ELSE
	RETURN ""
ENDIF

FUNCTION fldarray
PARAMETER tArray, cfield,aVals,nOffset
PRIVATE i
IF EMPTY(nOffset)
	nOffset=0
ENDIF
i=ASCAN(tArray,UPPER(cField))
IF i>0
	RETURN aVals(nOffset+CEILING(i/ALEN(tArray,2)))
ELSE
	RETURN ''
ENDIF